
%% Computing the characteristic value of operator -I/2 + K_D^omega for a disk


clear all;
close all;
clc;


r = 1; % radius of a disk
nbPoints = 500; %number of points on the boundary
theta = 2*pi*(0:nbPoints-1)/nbPoints;
D=ellipse(r,r,0,0,nbPoints); % make a unit disk 


%%% define a function which computes the smallest eigenvalue of the
%%% operator 'A=-I/2 + K_D^omega'
f = @(z) eigs((-1/2)*eye(D.nbPoints) + KD_Helm(z,D),1,'sm');


%%% compute the characteristic value of 'A' by applying muller's method
z0 = 1.9;
z1 = 1.8;
z2 = 1.7;
distTol = 5e-12; fTol = 1e-12; iterMax = 500;
[char_num, fRoot, iterN] = MullersMethod(f, z0, z1, z2, iterMax, distTol, fTol);

%%% copmute theoretical value (the first zero of J_1'(z))
char_theo = 1.8412 + 0.0000i;


%%% print output
fprintf('       In theory    |    Numerically');
[char_theo, char_num] %show eigenvalues


