function KD1 = KD1_Helm(k,D,h,dh,tau)


M = D.nbPoints;
KD1 = zeros(M, M);
K0 = zeros(M, M);
L0 = zeros(M, M);
L1 = zeros(M, M);
M0 = zeros(M, M);
M1 = zeros(M, M);
N0 = zeros(M, M);
N1 = zeros(M, M);
K11 = zeros(M, M);
K12 = zeros(M, M);
K13 = zeros(M, M);
K1 = zeros(M, M);
F1 = zeros(M, M);

for j = 1:M
    xdoty_norx = (D.points(1,j)-D.points(1,:)).*D.normal(1,j)...
        +(D.points(2,j)-D.points(2,:)).*D.normal(2,j);
    xdoty_nory = (D.points(1,j)-D.points(1,:)).*D.normal(1,:)...
        +(D.points(2,j)-D.points(2,:)).*D.normal(2,:);
    
    xdoty_tan = (D.points(1,j)-D.points(1,:)).*D.tvec(1,:)...
        +(D.points(2,j)-D.points(2,:)).*D.tvec(2,:);    
    norm_xy = sqrt((D.points(1,j)-D.points(1,:)).^2+(D.points(2,j)-D.points(2,:)).^2);
    
    L0(j,1:j-1) = 1i/4*k*besselh(1,1,k*norm_xy(1:j-1));
    L0(j,j+1:M) = 1i/4*k*besselh(1,1,k*norm_xy(j+1:M));

    L1(j,1:j-1) = 1i/4*k*( besselh(0,1,k*norm_xy(1:j-1))/2 - besselh(2,1,k*norm_xy(1:j-1))/2 ).* ... 
        (xdoty_norx(1:j-1)./norm_xy(1:j-1)*h(j)-xdoty_nory(1:j-1)./norm_xy(1:j-1).*h(1:j-1));
    L1(j,j+1:M) = 1i/4*k*( besselh(0,1,k*norm_xy(j+1:M))/2 - besselh(2,1,k*norm_xy(j+1:M))/2 ).* ... 
        (xdoty_norx(j+1:M)./norm_xy(j+1:M)*h(j)-xdoty_nory(j+1:M)./norm_xy(j+1:M).*h(j+1:M));
    
    M0(j,1:j-1) = norm_xy(1:j-1);
    M0(j,j+1:M) = norm_xy(j+1:M);
    
    M1(j,1:j-1) = (xdoty_norx(1:j-1)./norm_xy(1:j-1)*h(j)-xdoty_nory(1:j-1)./norm_xy(1:j-1).*h(1:j-1));
    M1(j,j+1:M) = (xdoty_norx(j+1:M)./norm_xy(j+1:M)*h(j)-xdoty_nory(j+1:M)./norm_xy(j+1:M).*h(j+1:M));
    
    N0(j,1:j-1) = D.sigma(1:(j-1)).*(-1).*xdoty_nory(1:(j-1))./(norm_xy(1:(j-1))).^2;
    N0(j,j+1:M) = D.sigma((j+1):M).*(-1).*xdoty_nory((j+1):M)./(norm_xy((j+1):M)).^2;
    
    K0(j,1:j-1) = (-1).*xdoty_nory(1:(j-1))./(norm_xy(1:(j-1))).^2;
    K0(j,j+1:M) = (-1).*xdoty_nory((j+1):M)./(norm_xy((j+1):M)).^2;
    
    
    K11(j,1:j-1) = h(1:j-1)./(norm_xy(1:j-1).^2)-h(j)./(norm_xy(1:j-1).^2).*(D.normal(1,1:j-1).*D.normal(1,j) + D.normal(2,1:j-1).*D.normal(2,j));
    K11(j,j+1:M) = h(j+1:M)./(norm_xy(j+1:M).^2)-h(j)./(norm_xy(j+1:M).^2).*(D.normal(1,j+1:M).*D.normal(1,j) + D.normal(2,j+1:M).*D.normal(2,j));
    
    K12(j,1:j-1) = tau(1:j-1).*h(1:j-1).*xdoty_nory(1:j-1)./(norm_xy(1:j-1).^2);
    K12(j,j+1:M) = tau(j+1:M).*h(j+1:M).*xdoty_nory(j+1:M)./(norm_xy(j+1:M).^2);
    
    K13(j,1:j-1) = dh(1:j-1).*xdoty_tan(1:j-1)./(norm_xy(1:j-1).^2);
    K13(j,j+1:M) = dh(j+1:M).*xdoty_tan(j+1:M)./(norm_xy(j+1:M).^2);
    
    K1(j,1:j-1) = K11(j,1:j-1) + K12(j,1:j-1) + K13(j,1:j-1);
    K1(j,j+1:M) = K11(j,j+1:M) + K12(j,j+1:M) + K13(j,j+1:M);
    
    F=M1;
    F1(j,1:j-1) = -2*F(j,1:j-1) + tau(j)*h(j) - tau(1:j-1).*h(1:j-1); 
    F1(j,j+1:M) = -2*F(j,j+1:M) + tau(j)*h(j) - tau(j+1:M).*h(j+1:M); 
    
    N1(j,1:j-1) = (K0(j,1:j-1).*F1(j,1:j-1) + K1(j,1:j-1)).*D.sigma(1:j-1);
    N1(j,j+1:M) = (K0(j,j+1:M).*F1(j,j+1:M) + K1(j,j+1:M)).*D.sigma(j+1:M);
    
    KD1(j,1:j-1) = L0(j,1:j-1).*M0(j,1:j-1).*N1(j,1:j-1) + (L0(1:j-1).*M1(1:j-1) + L1(1:j-1).*M0(1:j-1)).*N0(1:j-1);
    KD1(j,j+1:M) = L0(j,j+1:M).*M0(j,j+1:M).*N1(j,j+1:M) + (L0(j+1:M).*M1(j+1:M) + L1(j+1:M).*M0(j+1:M)).*N0(j+1:M);
    
 
  
end



for j=2:M-1
   KD1(j,j) = (KD1(j, j-1)+KD1(j, j+1))/2; 
end
KD1(1,1) = (KD1(1,2) + KD1(1,M))/2;
KD1(M,M) = (KD1(M, M-1) + KD1(M,1))/2;


end

