function Ks = KDstar_Helm(k,D)
% Ks = Kstar(curve) returns the matrix representing the kernel of Kstar com
% puted on the C2boundary D.
% Recall that K^star[f](x) = \frac{1}{2 \pi} \int_{\partial D} \frac{ <x - y, \nu_x> }{|x -
% y |^2 } f(y) d \sigma(y).

% Compute K, the adjoint of Ks
M = D.nbPoints;
Ks = zeros(M, M);

for j = 1:M
    xdoty = (D.points(1,j)-D.points(1,:)).*D.normal(1,j)...
        +(D.points(2,j)-D.points(2,:)).*D.normal(2,j);
    
    
    norm_xy = sqrt((D(1,j)-D(1,:)).^2+(D(2,j)-D(2,:)).^2);
    
 
    Ks(j,1:j-1) = 1i/4*k*besselh(1,1,k*norm_xy(1:(j-1))).*D.sigma(1:(j-1)).*xdoty(1:(j-1))./norm_xy(1:(j-1));
    Ks(j,j+1:M) = 1i/4*k*besselh(1,1,k*norm_xy((j+1):M)).*D.sigma((j+1):M).* xdoty((j+1):M)./norm_xy((j+1):M);
    Ks(j,j) = -1/(4*pi)* ...
            D.avec(:,j)'*D.normal(:,j)/(D.tvec_norm(j)^2)*D.sigma(j);
 

    
  
end

end

