function [a1 a2] = al_asymp(D,w0,rV0,h,dh,tau,M0,M,eps)


a1_sum=zeros(M0);
a2_sum=zeros(M0);

theta = 2*pi*(0:M-1)/M;
w = w0 + rV0*exp(1i*theta);
dw = 2*pi/M*rV0*1i*exp(1i*theta);

for j=1:M
    
    A0 = (-1/2)*eye(M0) + KD_Helm(w(j),D);
    KD1 = KD1_Helm(w(j),D,h,dh,tau);
    integrand = 1/(2*1i*pi)*(A0\KD1);
    
    a1_sum = a1_sum + integrand * dw(j);
    a2_sum = a2_sum + 2*(w(j)-w0)*integrand * dw(j);

end

a1 = eps*trace(a1_sum);
a2 = eps*trace(a2_sum);
end

