function c2Ellipse = ellipse(a, b, cx, cy, nbPoints)
% returns a C2boundary object represeting the ellipse [a*cos(t);b*sin(t)]
% there is nbPoints on the boundary of that ellipse

theta = 2*pi*(0:nbPoints-1)/nbPoints;

points = [a*cos(theta)+cx ; b*sin(theta)+cy];
tvec = [-a*sin(theta) ; b*cos(theta)];
avec = [-a*cos(theta) ; -b*sin(theta)];
diff_parameter = ones(1,nbPoints)*2*pi/nbPoints;
c2Ellipse = C2boundary(points, tvec, avec, diff_parameter);

end

